namespace AircraftCarrier
{
    public partial class FormWarship : Form
    {
        private DrawingWarship _warship;
        public FormWarship()
        {
            InitializeComponent();
        }
        /// <summary>
        ///    
        /// </summary>
        private void Draw()
        {
            Bitmap bmp = new(pictureBoxWarship.Width, pictureBoxWarship.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _warship?.DrawTransport(gr);
            pictureBoxWarship.Image = bmp;
        }
        /// <summary>
        ///    "Create"
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreate_Click(object sender, EventArgs e)
        {          
            Random rnd = new();
            _warship = new DrawingWarship();
            _warship.Init(rnd.Next(100, 300), rnd.Next(1000, 2000), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)));
            _warship.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxWarship.Width, pictureBoxWarship.Height);
            toolStripStatusLabelSpeed.Text = $": {_warship.Warship.Speed}";
            toolStripStatusLabelWeight.Text = $": {_warship.Warship.Weight}";
            toolStripStatusLabelBodyColor.Text = $": {_warship.Warship.BodyColor.Name}";
            Draw();
        }
       
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _warship?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _warship?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _warship?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _warship?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void PictureBoxWarship_Resize(object sender, EventArgs e)
        {
            _warship?.ChangeBorders(pictureBoxWarship.Width,pictureBoxWarship.Height);
            Draw();
        }
    }
}